% 6 pilotes
pilote(jean, paris).
pilote(julie, paris).
pilote(marie, lille).
pilote(margot, amiens).
pilote(brigitte, toulouse).
pilote(bart, strasbourg).

% 3 avions
avion(a1, paris).
avion(a2, amiens).
avion(a3, grenoble).

% reseau 
vol(f01, a2, marie, lille, amiens).
vol(f02, a2, margot, boulogne, rennes).
vol(f03, a2, marie, rennes, boulogne).
vol(f04, a2, margot, rennes, amiens).
vol(f05, a2, marie, amiens, calais).
vol(f06, a2, margot, calais, boulogne).
vol(f07, a2, marie, boulogne, arras).
vol(f08, a2, margot, arras,lille).
vol(f09, a1, jean, paris, poitiers).
vol(f10, a1, julie, poitiers, brest).
vol(f11, a1, jean, poitiers, bordeaux).
vol(f12, a1, julie, bordeaux, limoges).
vol(f13, a1, julie, limoges, paris).
vol(f14, a3, brigitte, toulouse, montpellier).
vol(f15, a3, bart, toulouse, marseille).
vol(f16, a3, brigitte, marseille, lyon).
vol(f17, a3, bart, lyon, grenoble).
vol(f18, a3, brigitte, grenoble, strasbourg).
vol(f19, a3, bart, strasbourg, toulouse).


ville(X) :- pilote(_, X).
ville(X) :- avion(_, X).
ville(X) :- vol(_,_,_,X,_).
ville(X) :- vol(_,_,_,_,X).


pilote_en_service(P) :- 
    pilote(P,_), 
    vol(_, _, P, _, _).
pilote_pas_en_service(P) :- 
    pilote(P,_), 
    not pilote_en_service(P).

q6(P) :- pilote(P,V), vol(_,_,P,V,_).
q7(P) :- pilote(P,V), vol(_,_,P,V1,_), V != V1.
q8(P) :- pilote(P,_), not q6(P).
q9(P) :- pilote(P,_), not q7(P).


villes_connectees_un_ou_deux_vols(V1, V2) :-
    vol(_,_,_,V1,V2).
villes_connectees_un_ou_deux_vols(V1, V2) :-
    vol(_,_,_,V1,VZ),
    vol(_,_,_,VZ,V2).

villes_connectess(V,W) :- 
    vol(_,_,_,V,W).
villes_connectees(V,W) :-
    vol(_,_,_,V,Z),
    villes_connectees(Z,W).

villes_non_connectees(X,Y):-
    ville(X),
    ville(Y),
    not villes_connectees(X,Y).


