% boy(X) -- X est un garcon
boy(jean).
boy(paul).

% girl(X) -- X est une fille
girl(marie).
girl(joanna).

% likes(X,Y) -- X aime Y
likes(jean, marie).
likes(paul, joanna).
likes(joanna, paul). 
likes(joanna, jean).
likes(joanna, marie).
likes(jean, joanna).

unhappy_boy(X) :- 
    boy(X),
    girl(Y), 
    likes(X, Y),
    not likes(Y, X).

happy_boy(X) :- 
    boy(X),
    not unhappy_boy(X).

% kid(X) -- X est un gamin
kid(X) :- girl(X).
kid(X) :- boy(X).

notsuperhappy_girl(Y) :-
    girl(Y),
    boy(X),
    not likes(X,Y).
    
superhappy_girl(Y) :-
    girl(Y),
    not notsuperhappy_girl(Y).

% friend(X, Y) -- X est un.e ami.e de Y
friend(joanna, marie).
friend(paul, jean).
friend(jean, paul).

% friend est une relation reflexive
friend(Y,X) :- friend(X,Y).

% likes est une generalization de la relation friend
% friend est une specialisation de la relation likes
likes(X,Y) :- friend(X,Y).

% on aime les amis de ses amis
likes(X,Y) :- 
    kid(X), kid(Y), kid(Z),
    friend(X,Z),
    friend(Z,Y),
    X!=Y.
    





